{
===============================================================================
  Copyright (©) 2002. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 03-11-2002
  Versión actual: 1.0.1
  Fecha versión actual: 03-11-2004
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    03-11-2004    p32. Añadido campo 'ULTIMOCAMBIO'.
    
===============================================================================
}

unit TablaProveedores;

interface

uses
  //Generales
  SysUtils, Classes, Controls, IBSQL, cxGridDBTableView, cxCustomData, DB,
  //Particulares

  //Aplicacion
  Framework, StrFunc, Entidades, Constantes, BaseDatos,

  //Contador
  Contadores, RdxGestorContadores;

type
  TDatosProveedor = class(TObjeto)
  public
    Codigo : String;
    NifCif : String;
    Nombre : String;
    Calle : String;
    Numero : String;
    Piso : String;
    CodigoPostal : String;
    Poblacion : String;
    Provincia : String;
    Telefono1 : String;
    Telefono2 : String;
    Movil1 : String;
    Movil2 : String;
    Fax : String;
    Correo : String;
    PersonaContacto : String;
    Observaciones : String;
    Descuento : String;
    Distribucion : String;
    constructor Create; overload;
    constructor Create(CodigoProveedor : String); overload;
    procedure ObtenerDatos; override;
    procedure SalvarDatos;
  end;

  TdmTablaProveedores = class(TDataModule)
  private
    procedure IniciarSQL;
  public
    sqlInsertar : TStrings;
    sqlModificar : TStrings;
    sqlConsultar : TStrings;
    sqlEliminar : TStrings;
    sqlGrid : TStrings;

    //Metodos que llamaran a contador
    function DarNuevoCodigo : String;
    function IncrementarCodigo: boolean;
    function InsertarContador: boolean;
    function ValidarCodigo(Codigo : String) : Boolean;
    function FormatearCodigo(Codigo : String) : String;

    function ExisteCodigo(Codigo : String) : Boolean;
    constructor Create (AOwner : TComponent); override;
    destructor Destroy; override;
    procedure InicializarGridProveedores(var vGrid: TcxGridDBTableView);
    function DarCodProvMin : String;
    function DarCodProvMax : String;
    function DarNombreProvMin : String;
    function DarNombreProvMax : String;
  end;

var
  dmTablaProveedores: TdmTablaProveedores;

implementation

{$R *.DFM}

uses
  Literales;

constructor TdmTablaProveedores.Create (AOwner : TComponent);
begin
  inherited;
  sqlInsertar := TStringList.Create;
  sqlModificar := TStringList.Create;
  sqlConsultar := TStringList.Create;
  sqlEliminar := TStringList.Create;
  sqlGrid := TStringList.Create;
  IniciarSQL;
end;

destructor TdmTablaProveedores.Destroy;
begin
  sqlInsertar.Free;
  sqlModificar.Free;
  sqlConsultar.Free;
  sqlEliminar.Free;
  sqlGrid.Free;
  inherited;
end;

procedure TdmTablaProveedores.IniciarSQL;
begin
  with sqlInsertar do
  begin
    Add('INSERT INTO PROVEEDORES ');
    Add('(CODIGO, FECHAALTA, NIFCIF, NOMBRE, CALLE, ');
		Add('NUMERO, PISO, POBLACION, PROVINCIA, CODIGOPOSTAL, ');
		Add('TELEFONO1, TELEFONO2, MOVIL1, MOVIL2, FAX, ');
		Add('CORREO, PERSONACONTACTO, OBSERVACIONES, DESCUENTO, USUARIO, ');
    Add('DISTRIBUCION, ULTIMOCAMBIO) ');
		Add('VALUES (:CODIGO, :FECHAALTA, :NIFCIF, :NOMBRE, :CALLE, ');
		Add(':NUMERO, :PISO, :POBLACION, :PROVINCIA, :CODIGOPOSTAL, ');
		Add(':TELEFONO1, :TELEFONO2, :MOVIL1, :MOVIL2, :FAX, ');
		Add(':CORREO, :PERSONACONTACTO, :OBSERVACIONES, ');
		Add(':DESCUENTO, :USUARIO, :DISTRIBUCION, CURRENT_TIME)');
  end;

  with sqlModificar do
  begin
    Add('UPDATE PROVEEDORES SET ');
		Add('NIFCIF = :NIFCIF, ');
		Add('NOMBRE = :NOMBRE, ');
		Add('CALLE = :CALLE, ');
		Add('NUMERO = :NUMERO, ');
		Add('PISO = :PISO, ');
		Add('POBLACION = :POBLACION, ');
		Add('PROVINCIA = :PROVINCIA, ');
		Add('CODIGOPOSTAL = :CODIGOPOSTAL, ');
		Add('TELEFONO1 = :TELEFONO1, ');
		Add('TELEFONO2 = :TELEFONO2, ');
		Add('MOVIL1 = :MOVIL1, ');
		Add('MOVIL2 = :MOVIL2, ');
		Add('FAX = :FAX, ');
		Add('CORREO = :CORREO, ');
		Add('PERSONACONTACTO = :PERSONACONTACTO, ');
		Add('OBSERVACIONES = :OBSERVACIONES, ');
		Add('DESCUENTO = :DESCUENTO, ');
    Add('DISTRIBUCION = :DISTRIBUCION, ');
    Add('ULTIMOCAMBIO = CURRENT_TIME ');
		Add('WHERE (CODIGO = :CODIGO)');
  end;

  with sqlEliminar do
  begin
    Add('delete from PROVEEDORES ');
    Add('where CODIGO = :CODIGO');
  end;

  with sqlConsultar do
  begin
    Add('select * from PROVEEDORES ');
    Add('where CODIGO = :CODIGO');
  end;

  with sqlGrid do
  begin
    Add('select CODIGO, NIFCIF, NOMBRE, TELEFONO1, FAX, CORREO ');
    Add('from PROVEEDORES');
    Add('order by NOMBRE');
  end;
end;

function TdmTablaProveedores.DarNuevoCodigo : String;
begin
  Result := GestorContadores.darNuevoCodigo(contProveedores);
end;

function TdmTablaProveedores.IncrementarCodigo: boolean;
begin
  Result := GestorContadores.IncrementarValor(contProveedores);
end;

function TdmTablaProveedores.ValidarCodigo(Codigo : String) : Boolean;
begin
  Result := GestorContadores.ValidarCodigo(contProveedores, Codigo);
end;

function TdmTablaProveedores.FormatearCodigo(Codigo : String) : String;
begin
  Result := GestorContadores.FormatearCodigo(contProveedores, Codigo);
end;

function TdmTablaProveedores.ExisteCodigo(Codigo: String): Boolean;
var
  oSQL : TIBSQL;
  Contador : String;
begin
  Result := False;
  if EsCadenaVacia(Codigo) then
    Exit;
    
  oSQL := TIBSQL.Create(Self);
  with oSQL do
  begin
    Database := dmBaseDatos.BD;
    Transaction := dmBaseDatos.Transaccion;
    SQL.Add('select CODIGO ');
    SQL.Add('from PROVEEDORES ');
    SQL.Add('where CODIGO = :CODIGO');
    ParamByName('CODIGO').AsString := Codigo;
    try
      Prepare;
      ExecQuery;
      Contador := Fields[0].AsString;
      Result := (Codigo = Contador);
    finally
      Close;
      Transaction := NIL;
      Free;
    end;
  end;
end;

procedure TdmTablaProveedores.InicializarGridProveedores(var vGrid: TcxGridDBTableView);
var
  Columna : TcxGridDBColumn;
begin
  with vGrid do begin
    ClearItems;
    OptionsView.Footer := True;

    {Columna CODIGO}
    Columna := CreateColumn;
    Columna.DataBinding.FieldName := 'CODIGO';
    Columna.Caption := 'Código';
    Columna.Width := tamColCodigo;
    Columna.Options.Filtering := False;

    with TcxGridDBTableSummaryItem(DataController.Summary.FooterSummaryItems.Add) do
    try
      try
        BeginUpdate;
        Column := Columna;
        FieldName := Columna.DataBinding.FieldName;
        Format := 'Total: 0 proveedores';
        Kind := skCount;
      finally
        EndUpdate;
      end;
    except
      DataController.Summary.FooterSummaryItems.Delete(DataController.Summary.FooterSummaryItems.Count-1);
    end;

    {Columna NIFCIF}
    Columna := CreateColumn;
    Columna.DataBinding.FieldName := 'NIFCIF';
    Columna.Caption := 'NIF/CIF';
    Columna.Width := tamColNIFCIF;
    Columna.Options.Filtering := False;
    {Columna NOMBRE}
    Columna := CreateColumn;
    Columna.DataBinding.FieldName := 'NOMBRE';
    Columna.Caption := 'Nombre';
    Columna.Width := tamColNombre;
    Columna.Options.Filtering := False;
    Columna.SortOrder := soAscending;    
    {Columna TELEFONO 1}
    Columna := CreateColumn;
    Columna.DataBinding.FieldName := 'TELEFONO1';
    Columna.Caption := 'Teléfono 1';
    Columna.Width := tamColTelefono;
    Columna.Options.Filtering := False;
    {Columna FAX}
    Columna := CreateColumn;
    Columna.DataBinding.FieldName := 'FAX';
    Columna.Caption := 'Fax';
    Columna.Width := tamColTelefono;
    Columna.Options.Filtering := False;
    {Columna CORREO}
    Columna := CreateColumn;
    Columna.DataBinding.FieldName := 'CORREO';
    Columna.Caption := 'Correo electrónico';
    Columna.Width := tamColCorreo;
    Columna.Options.Filtering := False;
  end;
end;

function TdmTablaProveedores.InsertarContador: boolean;
begin
  Result := GestorContadores.InsertarContador(contProveedores);
end;

function TdmTablaProveedores.DarCodProvMax: String;
var
  oSQL : TIBSQL;
begin
  Result := '';

  oSQL := TIBSQL.Create(Self);
  with oSQL do
  begin
    Database := dmBaseDatos.BD;
    Transaction := dmBaseDatos.Transaccion;
    SQL.Add('select max(CODIGO) ');
    SQL.Add('from PROVEEDORES ');
    try
      Prepare;
      ExecQuery;
      Result := Fields[0].AsString;
    finally
      Close;
      Transaction := NIL;
      Free;
    end;
  end;
end;

function TdmTablaProveedores.DarCodProvMin: String;
var
  oSQL : TIBSQL;
begin
  Result := '';

  oSQL := TIBSQL.Create(Self);
  with oSQL do
  begin
    Database := dmBaseDatos.BD;
    Transaction := dmBaseDatos.Transaccion;
    SQL.Add('select min(CODIGO) ');
    SQL.Add('from PROVEEDORES ');
    try
      Prepare;
      ExecQuery;
      Result := Fields[0].AsString;
    finally
      Close;
      Transaction := NIL;
      Free;
    end;
  end;
end;

{ TDatosProveedor }

constructor TDatosProveedor.Create(CodigoProveedor: String);
begin
  inherited Create;
  Codigo := CodigoProveedor;
  ObtenerDatos;
end;

constructor TDatosProveedor.Create;
begin
  inherited Create;
end;

procedure TDatosProveedor.ObtenerDatos;
var
  oSQL : TIBSQL;
begin
  if EsCadenaVacia(Codigo) and EsCadenaVacia(Nombre) then
    raise Exception.Create(msgProvFaltaProv);

  oSQL := TIBSQL.Create(NIL);
  with oSQL do
  begin
    Database := dmBaseDatos.BD;
    Transaction := dmBaseDatos.Transaccion;
    SQL.Add('select * from PROVEEDORES ');
    if (not EsCadenaVacia(Codigo)) then
    begin
      SQL.Add('where CODIGO = :CODIGO');
      ParamByName('CODIGO').AsString := Codigo;
    end
    else begin
      SQL.Add('where NOMBRE = :NOMBRE');
      ParamByName('NOMBRE').AsString := Nombre;
    end;
    try
      Prepare;
      ExecQuery;
      if (RecordCount > 0) then
      begin
        Codigo := FieldByName('CODIGO').AsString;
        NifCif := FieldByName('NIFCIF').AsString;
        Nombre := FieldByName('NOMBRE').AsString;
        Calle := FieldByName('CALLE').AsString;
        Numero := FieldByName('NUMERO').AsString;
        Piso := FieldByName('PISO').AsString;
        CodigoPostal := FieldByName('CODIGOPOSTAL').AsString;
        Poblacion := FieldByName('POBLACION').AsString;
        Provincia := FieldByName('PROVINCIA').AsString;
        Telefono1 := FieldByName('TELEFONO1').AsString;
        Telefono2 := FieldByName('TELEFONO2').AsString;
        Movil1 := FieldByName('MOVIL1').AsString;
        Movil2 := FieldByName('MOVIL2').AsString;
        Fax := FieldByName('FAX').AsString;
        Correo := FieldByName('CORREO').AsString;
        PersonaContacto := FieldByName('PERSONACONTACTO').AsString;
        Observaciones := FieldByName('OBSERVACIONES').AsString;
        Descuento := FieldByName('DESCUENTO').AsString;
        Distribucion := FieldByName('DISTRIBUCION').AsString;
      end
      else begin
        raise Exception.CreateFmt(msgProvNoExisteProv, [Codigo]);
      end;
    finally
      Close;
      Transaction := NIL;
      Free;
    end;
  end;
end;

function TdmTablaProveedores.DarNombreProvMax: String;
var
  oSQL : TIBSQL;
begin
  Result := '';

  oSQL := TIBSQL.Create(Self);
  with oSQL do
  begin
    Database := dmBaseDatos.BD;
    Transaction := dmBaseDatos.Transaccion;
    SQL.Add('select max(NOMBRE) ');
    SQL.Add('from PROVEEDORES ');
    try
      Prepare;
      ExecQuery;
      Result := Fields[0].AsString;
    finally
      Close;
      Transaction := NIL;
      Free;
    end;
  end;
end;

function TdmTablaProveedores.DarNombreProvMin: String;
var
  oSQL : TIBSQL;
begin
  Result := '';

  oSQL := TIBSQL.Create(Self);
  with oSQL do
  begin
    Database := dmBaseDatos.BD;
    Transaction := dmBaseDatos.Transaccion;
    SQL.Add('select min(NOMBRE) ');
    SQL.Add('from PROVEEDORES ');
    try
      Prepare;
      ExecQuery;
      Result := Fields[0].AsString;
    finally
      Close;
      Transaction := NIL;
      Free;
    end;
  end;
end;

procedure TDatosProveedor.SalvarDatos;
var
  oSQL : TIBSQL;
begin
  oSQL := TIBSQL.Create(NIL);
  with oSQL do
  begin
    Database := dmBaseDatos.BD;
    Transaction := dmBaseDatos.Transaccion;

    if EsCadenaVacia(Codigo) then
    begin
      Codigo := dmTablaProveedores.DarNuevoCodigo;
      SQL.Assign(dmTablaProveedores.sqlInsertar);
      ParamByName('FECHAALTA').AsDateTime := dmBaseDatos.DarFecha;
      ParamByName('USUARIO').AsString := dmBaseDatos.Usuario;
    end
    else
      SQL.Assign(dmTablaProveedores.sqlModificar);

    ParamByName('CODIGO').AsString := Codigo;
    ParamByName('NIFCIF').AsString := NifCif;
    ParamByName('NOMBRE').AsString := Nombre;
    ParamByName('CALLE').AsString := Calle;
    ParamByName('NUMERO').AsString := Numero;
    ParamByName('PISO').AsString := Piso;
    ParamByName('CODIGOPOSTAL').AsString := CodigoPostal;
    ParamByName('POBLACION').AsString := Poblacion;
    ParamByName('PROVINCIA').AsString := Provincia;
    ParamByName('TELEFONO1').AsString := Telefono1;
    ParamByName('TELEFONO2').AsString := Telefono2;
    ParamByName('MOVIL1').AsString := Movil1;
    ParamByName('MOVIL2').AsString := Movil2;
    ParamByName('FAX').AsString := Fax;
    ParamByName('CORREO').AsString := Correo;
    ParamByName('PERSONACONTACTO').AsString := PersonaContacto;
    ParamByName('OBSERVACIONES').AsString := Observaciones;
    ParamByName('DESCUENTO').AsString := Descuento;
    ParamByName('DISTRIBUCION').AsString := Distribucion;
    try
      Prepare;
      try
        ExecQuery;
        dmTablaProveedores.IncrementarCodigo;        
      except
      end;
    finally
      Close;
      Transaction := NIL;
      Free;
    end;
  end;
end;

end.
